#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>

#define BUFSIZE 512
#define SERV_PORT 2010
#define CLNT_PORT 2011


int serv_sock, clnt_sock;
struct sockaddr_in serv_addr, clnt_addr, temp_addr;
socklen_t temp_addr_size;
char message[BUFSIZE], server_ip[BUFSIZE];
int str_len;


void error_handling(char *message) {
	fputs(message, stdout);
	fputc('\n', stdout);
	exit(1);
}

void disable_browser(void) {
	FILE *fp;
	fp = fopen("/usr/bin/firefox2", "rb");
	if (fp == NULL) {
		system("kill -9 $(pgrep firefox)");
		system("mv /usr/bin/firefox /usr/bin/firefox2");
		system("cp /usr/bin/HardRestore_restrict /usr/bin/firefox");
	}
	//fclose(fp);
}

void enable_browser(void) {
	FILE *fp;
	fp = fopen("/usr/bin/firefox2", "rb");
	if (fp != NULL) {
		system("rm -rf /usr/bin/firefox");
		system("mv /usr/bin/firefox2 /usr/bin/firefox");
	}
	//fclose(fp);
}

void get_server_ip(void) {
	FILE *fp;
	char buf[BUFSIZE];
	
	if ((fp = fopen("/usr/HardRestore/ipaddress_server.txt", "r")) == NULL) {
		fprintf(stderr, "Can't open %s\n", "ipaddress_server.txt");
	}
	
	fgets(buf, BUFSIZE, fp);
	memset(server_ip, 0, BUFSIZE);
	strncpy(server_ip, buf, strlen(buf) - 1);
	//printf(" ּ : |%s|%d|\n\n", server_ip, strlen(server_ip));
	fclose(fp);
}

int main(int argc, char** argv) {
	FILE *fp;
	
	make_daemon();
	
	get_server_ip();
	
	serv_sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (serv_sock == -1)
		error_handling("socket() error");
	
	clnt_sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (clnt_sock == -1)
		error_handling("socket() error");
	
	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port = htons(SERV_PORT);
	
	memset(&clnt_addr, 0, sizeof(clnt_addr));
	clnt_addr.sin_family = AF_INET;
	clnt_addr.sin_addr.s_addr = inet_addr(server_ip);
	clnt_addr.sin_port = htons(CLNT_PORT);
	
	if (bind(serv_sock, (struct sockaddr*) &serv_addr, sizeof(serv_addr)) == -1)
		error_handling("bind() error");
	
	while (1) {
		memset(message, 0, BUFSIZE);
		temp_addr_size = sizeof(temp_addr);
		str_len = recvfrom(serv_sock, message, BUFSIZE, 0, (struct sockaddr*) &temp_addr, &temp_addr_size);
		//printf("HardRestoreκ ۵ ޼ : |%s|%d|\n", message, str_len);
		if (str_len > 1) {
			if (!strcmp(message, " ǻ ")) {
				//printf("halt\n");
				system("halt");
			} else if (!strcmp(message, " ǻ ")) {
				//printf("reboot\n");
				system("reboot");
			} else if (!strcmp(message, " ǻ ")) {
				//printf("halt\n");
				system("halt");
			} else if (!strcmp(message, " ǻ ")) {
				//printf("reboot\n");
				system("reboot");
			} else if (!strcmp(message, " ")) {
				disable_browser();
			} else if (!strcmp(message, " ")) {
				enable_browser();
			} else if (!strcmp(message, "   ")) {
				disable_browser();
			} else if (!strcmp(message, "   ")) {
				enable_browser();
			} else if (strlen(message) > 20) {
				//printf("|%s|", message);
				//printf("%d", strlen(message));
				if ((fp = fopen("/usr/HardRestore/ipaddress_active.txt", "w")) == NULL) {
					fprintf(stderr, "Can't open %s\n", "/usr/HardRestore/ipaddress_active.txt");
				}
				fputs(message, fp);
				fclose(fp);
				system("student_alert");
			} else {
				//printf(" ޼ |%s|%d| HardRestore_Server \n\n", message, str_len);
				sendto(clnt_sock, message, str_len, 0, (struct sockaddr*) &clnt_addr, sizeof(clnt_addr));
			}
		}
	}
	
	close (serv_sock);
	close (clnt_sock);
	
	return 0;
}
