#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>

#define BUFSIZE 30
#define SERV_PORT 2010
#define CLNT_PORT 2011


int serv_sock;
struct sockaddr_in serv_addr, clnt_addr;
socklen_t clnt_addr_size;
char message[BUFSIZE];
int str_len;


void error_handling(char *message) {
	fputs(message, stdout);
	fputc('\n', stdout);
	exit(1);
}

int main(void) {
	make_daemon();
	
	FILE *fp;
	
	serv_sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (serv_sock == -1)
		error_handling("socket() error");
	
	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port = htons(CLNT_PORT);
	
	if (bind(serv_sock, (struct sockaddr*) &serv_addr, sizeof(serv_addr)) == -1)
		error_handling("bind() error");
	
	while (1) {
		memset(message, 0, BUFSIZE);
		clnt_addr_size = sizeof(clnt_addr);
		str_len = recvfrom(serv_sock, message, BUFSIZE, 0, (struct sockaddr*) &clnt_addr, &clnt_addr_size);
		if (str_len > 1) {
			//printf("HardRestore_Clientκ ۵ ޼ : |%s|%d|\n\n", message, str_len);
			
			if ((fp = fopen("/usr/HardRestore/ipaddress_active.txt", "a")) == NULL) {
				fprintf(stderr, "Can't open %s\n", "ipaddress_active.txt");
			}
			fputs(message, fp);
			fputs("\n", fp);
			fclose(fp);
		}
	}
	
	close (serv_sock);
	
	return 0;
}
