#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <gtk/gtk.h>

#define IPSIZE		17
#define COMPUTERS	50
#define PORT		2010
#define BUFSIZE	30


void show_admin_remove(GtkWidget *widget, gpointer window);
void show_admin_restore(GtkWidget *widget, gpointer window);
void show_admin_student_backup(GtkWidget *widget, gpointer window);
void show_admin_student_restore(GtkWidget *widget, gpointer window);
GdkPixbuf *create_pixbuf(const gchar * filename);

void show_ip_manager(void);
void init_list(GtkWidget *list);
void append_item(GtkWidget *widget, gpointer entry);
void remove_item(GtkWidget *widget, gpointer selection);
void removeAll_item(GtkWidget *widget, gpointer selection);
void save_item(GtkWidget *widget, gpointer window2);
void quit_item(GtkWidget *widget, gpointer window2);
gboolean foreach_func (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer fp);
void show_ip_list(void);
void open_ip_list(void);
void confirm_student(GtkWidget *widget, gpointer label);
void active_ip_list(void);
void send_message(GtkWidget *widget, gpointer btn);
void selection_foreach (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer data);
void error_handling(char *message);
void show_user_list(void);
void show_user_cnt(gpointer label2);
void send_string(GtkWidget *widget, gpointer entry);
void show_about(GtkWidget *widget, gpointer data);


//////////////////////////////////////////////////////////////////////
//  
enum {				// ip_manager
	LIST_ITEM = 0,
	N_COLUMNS
};

GtkWidget *list_main, *list;
GtkTreeSelection *selection_main, *selection_ip;

gint num_ipaddress = 0;
gint num_user = 0;
char data[COMPUTERS][IPSIZE];
char user[COMPUTERS][IPSIZE];
//////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////
// HardRestore _ ϼ
int main(int argc, char** argv) {
	make_daemon();
	
	GtkWidget *label1, *label2, *label3, *label4, *label5, *label6, *label7, *label8;
	GtkWidget *window;
	GtkWidget *vbox, *hbox, *frame1, *frame2, *frame3;
	GtkWidget *btn1, *btn2, *btn3, *btn4, *btn5, *btn6, *btn7, *btn8, *btn9, *btn10, *btn11, *btn12, *btn13, *btn14, *btn15, *btn16, *btn17;
	GtkWidget *entry;
	
	gtk_init(&argc, &argv);
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window), " ǻͽ  α׷");
	gtk_window_set_icon(GTK_WINDOW(window), create_pixbuf("/usr/HardRestore/logo.png"));
	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
	gtk_window_set_default_size(GTK_WINDOW(window), 800, 670);
	gtk_window_set_resizable(GTK_WINDOW(window), FALSE);
	
	vbox = gtk_vbox_new(FALSE, 20);
	hbox = gtk_hbox_new(TRUE, 0);
	frame1 = gtk_fixed_new();
	frame2 = gtk_fixed_new();
	frame3 = gtk_fixed_new();
	
	
	btn1 = gtk_button_new_with_label(" ޴ ");
	gtk_widget_set_size_request(btn1, 170, 35);
	gtk_fixed_put(GTK_FIXED(frame1), btn1, 20, 10);
	
	btn2 = gtk_button_new_with_label(" ޴ ");
	gtk_widget_set_size_request(btn2, 170, 35);
	gtk_fixed_put(GTK_FIXED(frame1), btn2, 20, 50);
	
	btn3 = gtk_button_new_with_label("student  ");
	gtk_widget_set_size_request(btn3, 170, 35);
	gtk_fixed_put(GTK_FIXED(frame1), btn3, 20, 100);
	
	btn4 = gtk_button_new_with_label("student  ");
	gtk_widget_set_size_request(btn4, 170, 35);
	gtk_fixed_put(GTK_FIXED(frame1), btn4, 20, 140);
	
	label1 = gtk_label_new("student   ޴  մϴ.");
	gtk_fixed_put(GTK_FIXED(frame1), label1, 205, 20);
	label2 = gtk_label_new("student   ޴  ϰ մϴ.");
	gtk_fixed_put(GTK_FIXED(frame1), label2, 205, 60);
	label3 = gtk_label_new(" student   ̹ մϴ.\n(!! student     ƴմϴ.)                         ");
	gtk_fixed_put(GTK_FIXED(frame1), label3, 205, 105);
	label4 = gtk_label_new("  ̹ student  մϴ.\n( Ŀ 2   ð μ.)");
	gtk_fixed_put(GTK_FIXED(frame1), label4, 205, 145);

	
	
	btn5 = gtk_button_new_with_label("α׷ ");
	gtk_widget_set_size_request(btn5, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn5, 0, 0);
	
	btn6 = gtk_button_new_with_label("л ǻ IP ");
	gtk_widget_set_size_request(btn6, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn6, 0, 40);
	
	btn7 = gtk_button_new_with_label("   ħ");
	gtk_widget_set_size_request(btn7, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn7, 145, 40);
	
	btn17 = gtk_button_new_with_label("α׷ ");
	gtk_widget_set_size_request(btn17, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn17, 145, 0);
	
	
	
	label7 = gtk_label_new(" ǻͿ  : ");
	gtk_fixed_put(GTK_FIXED(frame2), label7, 0, 95);
	
	btn8 = gtk_button_new_with_label(" ǻ ");
	gtk_widget_set_size_request(btn8, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn8, 0, 110);
	
	btn9 = gtk_button_new_with_label(" ǻ ");
	gtk_widget_set_size_request(btn9, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn9, 145, 110);
	
	btn10 = gtk_button_new_with_label(" ");
	gtk_widget_set_size_request(btn10, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn10, 0, 150);
	
	btn11 = gtk_button_new_with_label(" ");
	gtk_widget_set_size_request(btn11, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn11, 145, 150);
	
	
	
	label8 = gtk_label_new(" ǻͿ  : ");
	gtk_fixed_put(GTK_FIXED(frame2), label8, 0, 205);
	
	btn12 = gtk_button_new_with_label(" ǻ ");
	gtk_widget_set_size_request(btn12, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn12, 0, 220);
	
	btn13 = gtk_button_new_with_label(" ǻ ");
	gtk_widget_set_size_request(btn13, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn13, 145, 220);
	
	btn14 = gtk_button_new_with_label("   ");
	gtk_widget_set_size_request(btn14, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn14, 0, 260);
	
	btn15 = gtk_button_new_with_label("   ");
	gtk_widget_set_size_request(btn15, 140, 35);
	gtk_fixed_put(GTK_FIXED(frame2), btn15, 145, 260);
	
	
	
	label5 = gtk_label_new("\n");
	gtk_fixed_put(GTK_FIXED(frame3), label5, 20, 0);
	
	label6 = gtk_label_new("л ǻͿ ޼ ϱ :\n\n\n");
	gtk_fixed_put(GTK_FIXED(frame3), label6, 20, 20);
	
	entry = gtk_entry_new_with_max_length(90);
	gtk_entry_set_width_chars(GTK_ENTRY(entry), 65);
	gtk_fixed_put(GTK_FIXED(frame3), entry, 20, 40);
	
	btn16 = gtk_button_new_with_label("ϱ");
	gtk_widget_set_size_request(btn16, 100, 25);
	gtk_fixed_put(GTK_FIXED(frame3), btn16, 487, 40);
	
	
	
	
	GtkWidget *sw;
	
	sw = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(sw), GTK_SHADOW_ETCHED_IN);
	
	list_main = gtk_tree_view_new();
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(list_main), TRUE);
	
	init_list(list_main);
	selection_main = gtk_tree_view_get_selection(GTK_TREE_VIEW(list_main));
	gtk_tree_selection_set_mode(selection_main, GTK_SELECTION_MULTIPLE);
	
	gtk_container_add(GTK_CONTAINER(sw), list_main);
	gtk_box_pack_start(GTK_BOX(hbox), sw, TRUE, TRUE, 20);
	gtk_container_add(GTK_CONTAINER(hbox), frame2);
	gtk_container_add(GTK_CONTAINER(vbox), frame1);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 1);
	gtk_container_add(GTK_CONTAINER(vbox), frame3);
	gtk_container_add(GTK_CONTAINER(window), vbox);
	
	
	gtk_widget_show_all(window);
	
	g_signal_connect(window, "destroy", G_CALLBACK(gtk_main_quit), NULL);
	g_signal_connect(btn1, "clicked", G_CALLBACK(show_admin_remove), NULL);
	g_signal_connect(btn2, "clicked", G_CALLBACK(show_admin_restore), NULL);
	g_signal_connect(btn3, "clicked", G_CALLBACK(show_admin_student_backup), NULL);
	g_signal_connect(btn4, "clicked", G_CALLBACK(show_admin_student_restore), NULL);
	g_signal_connect(btn5, "clicked", G_CALLBACK(gtk_main_quit), NULL);
	g_signal_connect(btn6, "clicked", G_CALLBACK(show_ip_manager), NULL);
	g_signal_connect(btn7, "clicked", G_CALLBACK(confirm_student), label5);
	g_signal_connect(btn8, "clicked", G_CALLBACK(send_message), btn8);
	g_signal_connect(btn9, "clicked", G_CALLBACK(send_message), btn9);
	g_signal_connect(btn10, "clicked", G_CALLBACK(send_message), btn10);
	g_signal_connect(btn11, "clicked", G_CALLBACK(send_message), btn11);
	g_signal_connect(btn12, "clicked", G_CALLBACK(send_message), btn12);
	g_signal_connect(btn13, "clicked", G_CALLBACK(send_message), btn13);
	g_signal_connect(btn14, "clicked", G_CALLBACK(send_message), btn14);
	g_signal_connect(btn15, "clicked", G_CALLBACK(send_message), btn15);
	g_signal_connect(btn16, "clicked", G_CALLBACK(send_string), entry);
	g_signal_connect(btn17, "clicked", G_CALLBACK(show_about), NULL);
	
	open_ip_list();
	confirm_student(label5, label5);
	
	gtk_main();
	
	return 0;
}

void show_admin_remove(GtkWidget *widget, gpointer window) {
	GtkWidget *dialog;
	gint result;
	
	dialog = gtk_message_dialog_new(window,
		GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_QUESTION,
		GTK_BUTTONS_YES_NO,
		"\" ޴ \" մϱ?");
		
	gtk_window_set_title(GTK_WINDOW(dialog), " ޴ ");
	
	result = gtk_dialog_run(GTK_DIALOG(dialog));
	
	switch (result) {
		case GTK_RESPONSE_YES:
			if (system("rm -rf /etc/xdg/menus/settings.menu") < 0)
				printf("error at admin_remove");

			if (system("rm -rf /etc/xdg/menus/gnomecc.menu") < 0)
				printf("error at admin_remove");
			break;
			
		case GTK_RESPONSE_NO:
			break;
	}
	
	gtk_widget_destroy(dialog);
}

void show_admin_restore(GtkWidget *widget, gpointer window) {
	GtkWidget *dialog;
	gint result;
	
	dialog = gtk_message_dialog_new(window,
		GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_QUESTION,
		GTK_BUTTONS_YES_NO,
		"\" ޴ \" մϱ?");
		
	gtk_window_set_title(GTK_WINDOW(dialog), " ޴ ");
	
	result = gtk_dialog_run(GTK_DIALOG(dialog));
	
	switch (result) {
		case GTK_RESPONSE_YES:
			if (system("cp /etc/xdg/menus/settings-linux.menu /etc/xdg/menus/settings.menu") < 0)
				printf("error at admin_restore");
			if (system("cp /etc/xdg/menus/gnomecc-linux.menu /etc/xdg/menus/gnomecc.menu") < 0)
				printf("error at admin_restore");
			break;
			
		case GTK_RESPONSE_NO:
			break;
	}
	
	gtk_widget_destroy(dialog);
}

void show_admin_student_backup(GtkWidget *widget, gpointer window) {
	GtkWidget *dialog;
	gint result;
	
	dialog = gtk_message_dialog_new(window,
		GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_QUESTION,
		GTK_BUTTONS_YES_NO,
		"\"student  \" մϱ?\n\nstudent     ƴմϴ.");
		
	gtk_window_set_title(GTK_WINDOW(dialog), "student  ");
	
	result = gtk_dialog_run(GTK_DIALOG(dialog));
	
	switch (result) {
		case GTK_RESPONSE_YES:
			if (system("rm -rf /var/lstr/detail/* ; cp -R /home/student /var/lstr/detail/orgs ; chown -R student.student /var/lstr/detail/orgs ; cd /var/lstr/detail ; tar -zcf orgs.t orgs/ ; rm -rf orgs/ ; cd") < 0)
				printf("error at backup_student");
			break;
			
		case GTK_RESPONSE_NO:
			break;
	}
	
	gtk_widget_destroy(dialog);
}

void show_admin_student_restore(GtkWidget *widget, gpointer window) {
	GtkWidget *dialog;
	gint result;
	
	dialog = gtk_message_dialog_new(window,
		GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_QUESTION,
		GTK_BUTTONS_YES_NO,
		"\"student  \" մϱ?\n\nstudent  ڵ    ϼ.");
		
	gtk_window_set_title(GTK_WINDOW(dialog), "student  ");
	
	result = gtk_dialog_run(GTK_DIALOG(dialog));
	
	switch (result) {
		case GTK_RESPONSE_YES:
			if (system("rm -rf /home/student ; cd /var/lstr/detail ; tar -zxf orgs.t ; mv orgs/ /home/student ; cd") < 0)
				printf("error at restore_student");
			break;
			
		case GTK_RESPONSE_NO:
			break;
	}
	
	gtk_widget_destroy(dialog);
}

GdkPixbuf *create_pixbuf(const gchar * filename) {
	GdkPixbuf *pixbuf;
	GError *error = NULL;
	pixbuf = gdk_pixbuf_new_from_file(filename, &error);
	if (!pixbuf) {
		fprintf(stderr, "%s\n", error->message);
		g_error_free(error);
	}
	return pixbuf;
}
//////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////
// ip_manager
void show_ip_manager(void) {
	GtkWidget *window2;
	GtkWidget *sw;
	GtkWidget *vbox, *hbox1, *hbox2;
	
	GtkWidget *label;
	GtkWidget *entry;
	GtkWidget *append;
	GtkWidget *remove;
	GtkWidget *removeAll;
	GtkWidget *save;
	GtkWidget *quit;
	
	window2 = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window2), "л ǻ IP ");
	gtk_window_set_icon(GTK_WINDOW(window2), create_pixbuf("/usr/HardRestore/logo.png"));
	gtk_window_set_position(GTK_WINDOW(window2), GTK_WIN_POS_CENTER);
	gtk_window_set_modal(GTK_WINDOW(window2), TRUE);
	//gtk_window_set_default_size(GTK_WINDOW(window2), 370, 270);
	gtk_widget_set_size_request(window2, 370, 270);
	gtk_container_set_border_width(GTK_CONTAINER(window2), 0);
	
	sw = gtk_scrolled_window_new(NULL, NULL);
	list = gtk_tree_view_new();
	
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(sw), GTK_SHADOW_ETCHED_IN);
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(list), FALSE);
	
	vbox = gtk_vbox_new(FALSE, 0);
	hbox1 = gtk_hbox_new(TRUE, 0);
	hbox2 = gtk_hbox_new(TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), sw, TRUE, TRUE, 5);
	
	label = gtk_label_new("IP ּ :");
	entry = gtk_entry_new();
	append = gtk_button_new_with_label("߰");
	remove = gtk_button_new_with_label("");
	removeAll = gtk_button_new_with_label(" ");
	save = gtk_button_new_with_label("");
	quit = gtk_button_new_with_label("");
	
	gtk_box_pack_start(GTK_BOX(hbox1), label, FALSE, TRUE, 1);
	gtk_box_pack_start(GTK_BOX(hbox1), entry, FALSE, TRUE, 1);
	gtk_box_pack_start(GTK_BOX(hbox1), append, FALSE, TRUE, 1);
	gtk_box_pack_start(GTK_BOX(hbox1), remove, FALSE, TRUE, 1);
	gtk_box_pack_start(GTK_BOX(hbox1), removeAll, FALSE, TRUE, 1);
	
	gtk_box_pack_start(GTK_BOX(hbox2), save, FALSE, TRUE, 1);
	gtk_box_pack_start(GTK_BOX(hbox2), quit, FALSE, TRUE, 1);
	
	gtk_box_pack_start(GTK_BOX(vbox), hbox1, FALSE, TRUE, 1);
	gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, TRUE, 1);
	
	gtk_container_add(GTK_CONTAINER(sw), list);
	gtk_container_add(GTK_CONTAINER(window2), vbox);
	
	init_list(list);
	
	selection_ip = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
	
	g_signal_connect(G_OBJECT(append),		"clicked", G_CALLBACK(append_item), entry);
	g_signal_connect(G_OBJECT(remove),		"clicked", G_CALLBACK(remove_item), selection_ip);
	g_signal_connect(G_OBJECT(removeAll),	"clicked", G_CALLBACK(removeAll_item), selection_ip);
	g_signal_connect(G_OBJECT(save),		"clicked", G_CALLBACK(save_item), window2);
	g_signal_connect(G_OBJECT(quit),		"clicked", G_CALLBACK(quit_item), window2);
	
	gtk_widget_show_all(window2);
	
	show_ip_list();
}

void init_list(GtkWidget *list) {
	GtkCellRenderer    *renderer;
	GtkTreeViewColumn  *column;
	GtkListStore       *store;

	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes("  л ǻ", renderer, "text", LIST_ITEM, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW (list), column);

	store = gtk_list_store_new (N_COLUMNS, G_TYPE_STRING);

	gtk_tree_view_set_model(GTK_TREE_VIEW (list), 
	GTK_TREE_MODEL(store));

	g_object_unref(store);
}

void append_item(GtkWidget *widget, gpointer entry) {
	GtkListStore *store;
	GtkTreeIter  iter;
	
	const gchar *str = gtk_entry_get_text(entry);
	
	if (strlen(str)) {
		store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
		
		gtk_list_store_append(store, &iter);
		gtk_list_store_set(store, &iter, LIST_ITEM, str, -1);
		
		gtk_entry_set_text(entry, "");
	}
}

void remove_item(GtkWidget *widget, gpointer selection) {
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter  iter;

	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) 
		return;

	if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(selection), &model, &iter)) {
		gtk_list_store_remove(store, &iter);
	}
}

void removeAll_item(GtkWidget *widget, gpointer selection) {
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter  iter;

	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) 
		return;
	gtk_list_store_clear(store);
}

void save_item(GtkWidget *widget, gpointer window2) {
	/*
	char buf[5];
	sprintf(buf, "%d", aa);
	gtk_entry_set_text(entry, buf);
	*/
	
	GtkListStore *store;

	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
	
	FILE *fp;
	if ((fp = fopen("/usr/HardRestore/ipaddress.txt", "w")) == NULL) {
		fprintf(stderr, "Can't open %s\n", "ipaddress.txt");
	}
	
	//gtk_tree_model_foreach(GTK_TREE_MODEL(store), foreach_func, NULL);
	gtk_tree_model_foreach(GTK_TREE_MODEL(store), foreach_func, fp);
	
	fclose(fp);
	
	open_ip_list();
	
	gtk_widget_destroy(window2);
}

void quit_item(GtkWidget *widget, gpointer window2) {
	gtk_widget_destroy(window2);
}

//gboolean foreach_func (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer user_data) {
gboolean foreach_func (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer fp) {
	gchar *list_item, *tree_path_str;

	gtk_tree_model_get(model, iter, LIST_ITEM, &list_item, -1);

	tree_path_str = gtk_tree_path_to_string(path);

	//g_print ("Row %s: %s\n", tree_path_str, list_item);
	// ⿡  Ѵ.
	fputs(list_item, fp);
	fputs("\n", fp);
	
	g_free(tree_path_str);
	g_free(list_item);

	return FALSE;
}

void show_ip_list(void) {
	GtkListStore *store;
	GtkTreeIter  iter;
	gint i;
	
	for (i = 0 ; i <= num_ipaddress - 1 ; i++) {
		store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
		gtk_list_store_append(store, &iter);
		gtk_list_store_set(store, &iter, LIST_ITEM, data[i], -1);
	}
}

void open_ip_list(void) {
	FILE *fp;
	char buf[IPSIZE], temp[IPSIZE];
	gint i, j;
	
	if ((fp = fopen("/usr/HardRestore/ipaddress.txt", "r")) == NULL) {
		fprintf(stderr, "Can't open %s\n", "ipaddress.txt");
	}
	
	num_ipaddress = 0;
	while ((fgets(buf, IPSIZE, fp) != NULL) && num_ipaddress < COMPUTERS) {
		memset(data[num_ipaddress], 0, IPSIZE);
		strncpy(data[num_ipaddress], buf, strlen(buf) - 1);
		//g_print ("|%s|", data[num_ipaddress]);
		num_ipaddress++;
	}
	//g_print ("%d\n", num_ipaddress);
	for (i = 0 ; i < num_ipaddress - 1 ; i++) {
		for (j = i + 1 ; j < num_ipaddress ; j++) {
			if (strcmp(data[j-1], data[j]) > 0) {
				strcpy(temp, data[j-1]);
				strcpy(data[j-1], data[j]);
				strcpy(data[j], temp);
			}
		}
	}
	
	fclose(fp);
}

void confirm_student(GtkWidget *widget, gpointer label) {
	gint i, j;
	
	//g_print ("\n\n\nü student : |%d|\n", num_ipaddress);
	
	for (i = 0 ; i <= num_ipaddress - 1 ; i++) {
		//g_print ("ipּ : |%s|%d|\n", data[i], strlen(data[i]));
	}
	
	
	int sock;
	struct sockaddr_in serv_addr, from_addr;
	socklen_t addr_size;
	int str_len;
	
	FILE *fp;
	//system("rm -rf /usr/HardRestore/ipaddress_active.txt");
	if ((fp = fopen("/usr/HardRestore/ipaddress_active.txt", "w")) == NULL) {
		fprintf(stderr, "Can't open %s\n", "ipaddress_active.txt");
	}
	fclose(fp);
	
	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (sock == -1)
		error_handling("socket() error");
	
	for (i = 0 ; i <= num_ipaddress - 1 ; i++) {
		memset(&serv_addr, 0, sizeof(serv_addr));
		serv_addr.sin_family = AF_INET;
		serv_addr.sin_addr.s_addr = inet_addr(data[i]);
		serv_addr.sin_port = htons(PORT);
		
		sendto(sock, data[i], strlen(data[i]), 0, (struct sockaddr*) &serv_addr, sizeof(serv_addr));
		//g_print ("ipּ : |%s|        udp ޼ : | Ȯ|\n", data[i]);
	}
	
	close (sock);
	
	sleep(3);
	
	active_ip_list();
	show_user_list();
	show_user_cnt(label);
}

void active_ip_list(void) {
	FILE *fp;
	char buf[IPSIZE], temp[IPSIZE];
	gint i, j;
	
	if ((fp = fopen("/usr/HardRestore/ipaddress_active.txt", "r")) == NULL) {
		fprintf(stderr, "Can't open %s\n", "ipaddress_active.txt");
	}
	
	num_user = 0;
	while ((fgets(buf, IPSIZE, fp) != NULL) && num_user < num_ipaddress) {
		memset(user[num_user], 0, IPSIZE);
		strncpy(user[num_user], buf, strlen(buf) - 1);
		//g_print ("Ȱȭ student : |%s|\n", user[num_user]);
		num_user++;
	}
	//g_print ("Ȱȭ student : |%d|\n\n", num_user);
	for (i = 0 ; i < num_user - 1 ; i++) {
		for (j = i + 1 ; j < num_user ; j++) {
			if (strcmp(user[j-1], user[j]) > 0) {
				strcpy(temp, user[j-1]);
				strcpy(user[j-1], user[j]);
				strcpy(user[j], temp);
			}
		}
	}
	
	fclose(fp);
}

void send_message(GtkWidget *widget, gpointer btn) {
	gint i, j;
	/*
	g_print ("\n\n\n student : |%d|\n", num_user);
	
	for (i = 0 ; i <= num_user - 1 ; i++) {
		g_print ("ipּ : |%s|%d|\n", user[i], strlen(user[i]));
	}
	*/
	
	//g_print("ư ̸ : |%s|\n", gtk_button_get_label(btn));
	
	
	int sock;
	struct sockaddr_in serv_addr, from_addr;
	socklen_t addr_size;
	int str_len;
	
	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (sock == -1)
		error_handling("socket() error");
	
	if ((!strcmp(gtk_button_get_label(btn), " ǻ ")) || (!strcmp(gtk_button_get_label(btn), " ǻ ")) || (!strcmp(gtk_button_get_label(btn), "   ")) || (!strcmp(gtk_button_get_label(btn), "   "))) {
		//g_print ("õ ڵ  : %d\n", gtk_tree_selection_count_selected_rows(selection_main));
		gtk_tree_selection_selected_foreach(selection_main, selection_foreach, btn);
	} else {
		for (i = 0 ; i <= num_user - 1 ; i++) {
			memset(&serv_addr, 0, sizeof(serv_addr));
			serv_addr.sin_family = AF_INET;
			serv_addr.sin_addr.s_addr = inet_addr(user[i]);
			serv_addr.sin_port = htons(PORT);
			
			sendto(sock, gtk_button_get_label(btn), strlen(gtk_button_get_label(btn)), 0, (struct sockaddr*) &serv_addr, sizeof(serv_addr));
			//g_print ("ipּ : |%s|        udp ޼ : |%s|\n", user[i], gtk_button_get_label(btn));
		}
	}
	
	close (sock);
}

void selection_foreach (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer data) {
	gchar *list_item, *tree_path_str;
	
	gtk_tree_model_get(model, iter, LIST_ITEM, &list_item, -1);
	
	tree_path_str = gtk_tree_path_to_string(path);
	
	//g_print ("Row %s: %s\n", tree_path_str, list_item);
	g_print ("ipּ : |%s|        udp ޼ : |%s|\n", list_item, gtk_button_get_label(data));
	
	
	int sock;
	struct sockaddr_in serv_addr, from_addr;
	socklen_t addr_size;
	int str_len;
	
	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (sock == -1)
		error_handling("socket() error");
	
	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = inet_addr(list_item);
	serv_addr.sin_port = htons(PORT);
	
	sendto(sock, gtk_button_get_label(data), strlen(gtk_button_get_label(data)), 0, (struct sockaddr*) &serv_addr, sizeof(serv_addr));
	
	close (sock);	
	
	
	g_free(tree_path_str);
	g_free(list_item);
}

void error_handling(char *message) {
	fputs(message, stdout);
	fputc('\n', stdout);
	exit(1);
}

void show_user_list(void) {
	GtkListStore *store;
	GtkTreeIter  iter;
	gint i;
	
	GtkTreeModel *model;
	
	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list_main)));
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(list_main));
	
	gtk_list_store_clear(store);
	
	for (i = 0 ; i <= num_user - 1 ; i++) {
		store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list_main)));
		gtk_list_store_append(store, &iter);
		gtk_list_store_set(store, &iter, LIST_ITEM, user[i], -1);
	}
}

void show_user_cnt(gpointer label) {
	//g_print (" л  ֱ = %d\n", num_user);
	char buf[50];
	memset(buf, 0, 50);
	sprintf(buf, " л  : %d  / %d ", num_user, num_ipaddress);
	gtk_label_set_text(label, buf);
}

void send_string(GtkWidget *widget, gpointer entry) {
	gint i;
	
	//g_print ("|%s|\n", gtk_entry_get_text(entry));
	//g_print ("|%d|\n", strlen(gtk_entry_get_text(entry)));
	
	int sock;
	struct sockaddr_in serv_addr, from_addr;
	socklen_t addr_size;
	int str_len;
	
	char sendString[512];
	memset(sendString, 0, 512);
	sprintf(sendString, "ڷκ ۵ ޼:\n\n\n%s\n\n", gtk_entry_get_text(entry));
	
	if (strlen(gtk_entry_get_text(entry)) > 0) {
		sock = socket(AF_INET, SOCK_DGRAM, 0);
		if (sock == -1)
			error_handling("socket() error");
		
		for (i = 0 ; i <= num_user - 1 ; i++) {
			memset(&serv_addr, 0, sizeof(serv_addr));
			serv_addr.sin_family = AF_INET;
			serv_addr.sin_addr.s_addr = inet_addr(user[i]);
			serv_addr.sin_port = htons(PORT);
			
			sendto(sock, sendString, strlen(sendString), 0, (struct sockaddr*) &serv_addr, sizeof(serv_addr));
			//g_print ("ipּ : |%s|        udp ޼ : |%s|\n", user[i], sendString);
		}
		
		close (sock);
		
		gtk_entry_set_text(entry, "");
	}
	
}

void show_about(GtkWidget *widget, gpointer data) {
	GdkPixbuf *pixbuf = gdk_pixbuf_new_from_file("/usr/HardRestore/logo.png", NULL);
	GtkWidget *dialog = gtk_about_dialog_new();
	
	gtk_about_dialog_set_name(GTK_ABOUT_DIALOG(dialog), "HardRestore");
	gtk_about_dialog_set_version(GTK_ABOUT_DIALOG(dialog), "0.0.1"); 
	gtk_about_dialog_set_copyright(GTK_ABOUT_DIALOG(dialog), "(c) anytools... 2010.10..");
	gtk_about_dialog_set_comments(GTK_ABOUT_DIALOG(dialog), "HardRestore is a simple management tool for Open Source Desktop Linux...");
	gtk_about_dialog_set_website(GTK_ABOUT_DIALOG(dialog), "http://www.spaceii.com");
	gtk_about_dialog_set_logo(GTK_ABOUT_DIALOG(dialog), pixbuf);
	g_object_unref(pixbuf), pixbuf = NULL;
	gtk_dialog_run(GTK_DIALOG (dialog));
	gtk_widget_destroy(dialog);
}
//////////////////////////////////////////////////////////////////////
