#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <gtk/gtk.h>


//////////////////////////////////////////////////////////////////////
// HardRestore_restrict ϼ
GdkPixbuf *create_pixbuf(const gchar * filename) {
	GdkPixbuf *pixbuf;
	GError *error = NULL;
	pixbuf = gdk_pixbuf_new_from_file(filename, &error);
	if (!pixbuf) {
		fprintf(stderr, "%s\n", error->message);
		g_error_free(error);
	}
	return pixbuf;
}


int main(int argc, char** argv) {
	GtkWidget *window;
	GtkWidget *dialog;
	gint result;
	
	gtk_init(&argc, &argv);
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	
	dialog = gtk_message_dialog_new(GTK_WINDOW(window),
		GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_ERROR,
		GTK_BUTTONS_OK, "\n ߿   ϴ.");
	gtk_window_set_title(GTK_WINDOW(dialog), " ");
	gtk_window_set_icon(GTK_WINDOW(dialog), create_pixbuf("/usr/HardRestore/logo.png"));
	
	result = gtk_dialog_run(GTK_DIALOG(dialog));
	
	gtk_widget_destroy(dialog);
	
	//g_print ("%d\n", result);
	
	return 0;
}
//////////////////////////////////////////////////////////////////////
